
var pInterval;
var xRotate=90;
var yRotate=180;
var zRotate = 0;
var lastX;
var lastY;
var dragging = false;
var canvas = document.getElementById("theCanvas");

SceneJS.createNode({
    type: "scene",
    id: "myScene",
    canvasId: "theCanvas" , // Bind to canvasDOM
    loggingElementId: "theLoggingDiv", // Log to DIV

    nodes: [
        {
            type: "lookAt",
            id: "theLookat",
            eye : { x: 0.0, y: 10.0, z: 350},
            look : { x: 0.0, y: 10.0, z: 0 },
            up : { y: 1.0 },

            nodes: [
                {
                    type: "camera",
                    id: "cameraID",
                    optics: {
                        type: "perspective",
                        fovy : 28.0,  
                        aspect : 1.47, 
                        near : 0.1,
                        far : 3000.0
                    },                    	
							      nodes: [
							          {
							              type: "rotate",
							              id: "xRotate",
							              angle : xRotate ,
							              x : 1.0,
							
							              nodes: [{
							                      type: "rotate",
							                      id: "yRotate",
							                      angle : yRotate,
							                      y : 1.0,
							                      nodes: [{
							                      	type: "rotate",
							                      	id:"zRotate",
							                      	angle: zRotate,
							                      	z: 40.0,
							                      	nodes:[{
							                      		type:"translate",
							                      		id:"senceNodesID",
							                      		x:-60,
								                      		nodes:[
								                          {
								                              type: "instance",
								                              id: "lei_id",
								                              target: "myModel.scene"
								                          }
								                      		]
							                      		}]
							                      	}]
							                  }]
							          }
							      ]
                }
            ]
        }
    ]
});


function mouseDown(event) {
    lastX = event.clientX;
    lastY = event.clientY;
    dragging = true;
}

function mouseUp() {
    dragging = false;
}

function mouseMove(event) {
    if (dragging) {
        xRotate += (event.clientY - lastY) * 0.5;
        zRotate += (event.clientX - lastX) * 0.5;
        lastX = event.clientX;
        lastY = event.clientY;
    }
}

function mouseWheel(event) {
	console.log("mouseWheel");
	console.log(event);
    var delta = 0;
    if (!event) event = window.event;
      delta = event.wheelDelta ? -event.wheelDelta/100: event.detail;  

    var eye = SceneJS.withNode("theLookat").get("eye");
    var eyeX = eye.x;
    var eyeY = eye.y;
    var eyeZ = eye.z;
    eyeZ += delta*20;
    
    SceneJS.withNode("theLookat").set("eye",{x:eyeX,y:eyeY,z:eyeZ});
    if (event.preventDefault)
        event.preventDefault();
     event.returnValue = false;
}

canvas.addEventListener('mousedown', mouseDown, true);
canvas.addEventListener('mousemove', mouseMove, true);
canvas.addEventListener('mouseup', mouseUp, true);
canvas.addEventListener('mousewheel', mouseWheel, true);
canvas.addEventListener('DOMMouseScroll', mouseWheel, true);
document.onkeydown = onKeyDown 
document.onkeyup = onKeyUp 
document.onkeypress = onKeyPress 

function onKeyDown(event){
    var eye = SceneJS.withNode("theLookat").get("eye");
    var look = SceneJS.withNode("theLookat").get("look");
    var MOVESTEEP = 5;

    switch(event.keyCode){
    	case 68:
    	console.log("a");
    	eye.x += MOVESTEEP;
    	look.x += MOVESTEEP;
    	break;
    	case 65:
    	console.log("d");
    	eye.x -= MOVESTEEP;
    	look.x -= MOVESTEEP;
    	break;
    	case 87:
    	console.log("w");
    	eye.y += MOVESTEEP;
    	look.y += MOVESTEEP;
    	break;
    	case 83:
    	console.log("s");
    	eye.y -= MOVESTEEP;
    	look.y -= MOVESTEEP;
    	break;
    	default:
    	break;
    	}
    
    SceneJS.withNode("theLookat").set("eye",eye);
    SceneJS.withNode("theLookat").set("look",look);
window.render();
	}
function onKeyUp(){
	}
function onKeyPress(){
	}

window.render = function() {
    SceneJS.withNode("xRotate").set("angle", xRotate);
    SceneJS.withNode("zRotate").set("angle", zRotate);
    SceneJS.withNode("myScene").render();
};

pInterval = setInterval("window.render()", 100);

SceneJS.bind("error", // Listen for errors on SceneJS
        function(event) {
            alert(event.exception.message);
            window.clearInterval(pInterval);
        });
